// vlastne triedy
#include "OGLobjects.h"
#include "OGLtext.h"
#include "OGLtexture.h"
#include "OGLcamera.h"
#include "BMPImage.h"
#include "glTriangle.h"
#include "glTerrain.h"
#include "OctTree.h"
#include "OGLext.h"

typedef struct __material { // struktura OpenGL materialu
 GLfloat amb[4],dif[4],spe[4],amb_dif[4],emi[4];
 GLfloat shi,transp,sillum[4];
} _material;

typedef struct __light {    // struktura OpenGL svetla
 GLfloat amb[4],dif[4],spe[4];
 GLfloat pos[4],spot[3];
} _light;

// trieda premennych a funkcii pre pracu s OpenGL
class COGL {
public:
 COGL();                      // konstruktor
 virtual ~COGL();             // destruktor

 COGLcamera ogl_camera[8];    // pouzite kamery

 bool gl_initialize(void);    // inicializacia OpenGL
 GLubyte gl_draw(void);       // vykreslenie OpenGL sceny

 // zmena stavov OpenGL stavoveho stroja -----------------------------------
 void change_PolygonMode(void);   // zmena sposobu zobrazenia objektov
 void change_FogMode(void);       // zmena parametrov hmly
 void change_TexOnOff(void);      // zap/vyp texturovania
 GLubyte normals_onoff;
 void change_NormalsOnOff(void);  // zap/vyp vykreslovania normal
 GLubyte octtree_onoff;
 void change_OctTreeOnOff(void);  // zap/vyp vykreslovania oktanoveho stromu
 GLubyte help_onoff;
 void change_HelpOnOff(void);     // zap/vyp vypisu helpu
 GLubyte lighting_onoff;          // zap/vyp osvetlenia
 void change_LightingOnOff(void); // zap/vyp osvetlenia
 GLubyte fog_onoff;               // zap/vyp hmly
 void change_FogOnOff(void);      // zap/vyp hmly

 OctTree m_OctTree; // pouzity oktanovy strom
private:
 GLfloat StartInfoPos;                // pozicia vypisu info
 void PrintStartInfo(char *infotext); // vypis info pocas startu aplikacie

 _material ogl_material[8]; // pouzite materialy
 _light ogl_light[8];       // pouzite svetla
 GLfloat ogl_fogColor[4]; // farba hmly

 GLuint t_a,t_b; // pomocne premenne

 GLint ogl_state[2]; // zistovanie stavov OpenGL stavoveho stroja

 // pouzite triedy ---------------------------------------------------------
 COGLtext ogl_text;       // instancia triedy COGLtext - praca s textom
 COGLtexture ogl_texture; // instancia triedy COGLtexture - praca s texturou

 COGLobjects ogl_object;  // pouzite jednoduche objekty

 glTerrain ogl_terrain;   // instancia triedy glTerrain - teren

 OGLext ogl_ext;

 GLfloat rot_x,rot_y;
};

