// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// funkcie a premenne pre pracu s BMP suborom
#include "BMPImage.h"
// funkcie a premenne pre pracu s trojuholnikmi
#include "glTriangle.h"

// .h subor
#include "glTerrain.h"

CBMPImage bmp_img; // instancia triedy CBMPImage

// konstruktor *************************************************************
glTerrain::glTerrain()
{

}

// destruktor **************************************************************
glTerrain::~glTerrain()
{

}

// orezanie hodnoty do intervalu <0;255> ***********************************
int limit255(int a)
{
 if (a<0) return 0;
 else if (a>255) return 255;
      else return a;
}

// preklapanie vyskovych poli **********************************************
float texture_factor(int h1,int h2)
{
 float t;
 t=(40-abs(h1-h2))/16.0f;

 if (t<0.0f) t=0.0f;
 else if (t>1.0f) t=1.0f;

 return t;
}

// ziskanie hodnot farebneho bodu zo zdrojovej textury *********************
void GET_COLOR(BMPIMAGE *tex,int x,int y,unsigned char *r,
                                         unsigned char *g,
                                         unsigned char *b)
{
 if ((x<(int) tex->w)&&(y<(int) tex->h)) {
  *r=tex->data[(x+(y*tex->w))*3+0];
  *g=tex->data[(x+(y*tex->w))*3+1];
  *b=tex->data[(x+(y*tex->w))*3+2];
 }
}

// priradenie hodnot farebnemu bodu cielovej textury ***********************
void SET_COLOR(BMPIMAGE tex,int x,int y,unsigned char r,
                                        unsigned char g,
                                        unsigned char b)
{
 if ((x<(int) tex.w)&&(y<(int) tex.h)) {
  tex.data[(x+(y*tex.w))*3+0]=b;
  tex.data[(x+(y*tex.w))*3+1]=g;
  tex.data[(x+(y*tex.w))*3+2]=r;
 }
}

// otexturovanie terenu ****************************************************
int glTerrain::terrain_texture(BMPIMAGE tt,unsigned char *hf)
{
 BMPIMAGE *tex[5];
 unsigned int x,y,xt,yt;
 float f0,f1,f2,f3,f4;
 unsigned int h1;
 unsigned char r[5],g[5],b[5];
 unsigned char new_r,new_g,new_b;

 tex[0]=NULL; tex[1]=NULL; tex[2]=NULL; tex[3]=NULL; tex[4]=NULL;

 // nacitanie 5-tich podtextur hlavnej textury
 char fname[256];
 strcpy(fname,"data/"); strcat(fname,"terrain/"); strcat(fname,"texture0_1.bmp\0");
 tex[0]=bmp_img.open_bitmap(fname);
 strcpy(fname,"data/"); strcat(fname,"terrain/"); strcat(fname,"texture0_1.bmp\0");
 tex[1]=bmp_img.open_bitmap(fname);
 strcpy(fname,"data/"); strcat(fname,"terrain/"); strcat(fname,"texture0_2.bmp\0");
 tex[2]=bmp_img.open_bitmap(fname);
 strcpy(fname,"data/"); strcat(fname,"terrain/"); strcat(fname,"texture0_2.bmp\0");
 tex[3]=bmp_img.open_bitmap(fname);
 strcpy(fname,"data/"); strcat(fname,"terrain/"); strcat(fname,"texture0_3.bmp\0");
 tex[4]=bmp_img.open_bitmap(fname);

 if ((tex[0]==NULL)||(tex[1]==NULL)||(tex[2]==NULL)||
     (tex[3]==NULL)||(tex[4]==NULL)) {
  fprintf(stderr,"Error opening terrain textures!\n");
  return(1);
 }

 for(y=0;y<tt.h;y++) {
  for(x=0;x<tt.w;x++) {
   h1=limit255(*(hf+3*x+3*1024*y));

   f4=texture_factor(256,h1);
   f3=texture_factor(192,h1);
   f2=texture_factor(128,h1);
   f1=texture_factor(64,h1);
   f0=texture_factor(0,h1);

   // na mapu 1024x1024 sa mapuju mensie textury velkosti 256x256
   if (x<256) xt=x;
   else if (x<512) xt=x-256;
        else if (x<768) xt=x-512;
             else xt=x-768;
   if (y<256) yt=y;
   else if (y<512) yt=y-256;
        else if (y<768) yt=y-512;
             else yt=y-768;
   // ziskanie hodnot farby z jednotlivych textur
   GET_COLOR(tex[0],xt,yt,&r[0],&g[0],&b[0]);
   GET_COLOR(tex[1],xt,yt,&r[1],&g[1],&b[1]);
   GET_COLOR(tex[2],xt,yt,&r[2],&g[2],&b[2]);
   GET_COLOR(tex[3],xt,yt,&r[3],&g[3],&b[3]);
   GET_COLOR(tex[4],xt,yt,&r[4],&g[4],&b[4]);
   // kombinacia ziskanych hodnot
   new_r=(unsigned char) limit255((int) ((r[0]*f0)+(r[1]*f1)+(r[2]*f2)+(r[3]*f3)+(r[4]*f4)));
   new_g=(unsigned char) limit255((int) ((g[0]*f0)+(g[1]*f1)+(g[2]*f2)+(g[3]*f3)+(g[4]*f4)));
   new_b=(unsigned char) limit255((int) ((b[0]*f0)+(b[1]*f1)+(b[2]*f2)+(b[3]*f3)+(b[4]*f4)));
   // priradenie vyslednej farby cielovej texture
   SET_COLOR(tt,x,y,new_r,new_g,new_b);
  }
 }
 // uvolnenie pouzitej pamate
 if (tex[4]!=NULL) bmp_img.close_bitmap(tex[4]);
 if (tex[3]!=NULL) bmp_img.close_bitmap(tex[3]);
 if (tex[2]!=NULL) bmp_img.close_bitmap(tex[2]);
 if (tex[1]!=NULL) bmp_img.close_bitmap(tex[1]);
 if (tex[0]!=NULL) bmp_img.close_bitmap(tex[0]);

 // vygenerovanie textury terenu
 glGenTextures(1,&terrain_texture_id);
 // pripojenie textury
 glBindTexture(GL_TEXTURE_2D,terrain_texture_id);
 // nastavenie LINEAR filteringu
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
 // vygenerovanie textury
 glTexImage2D(GL_TEXTURE_2D,0,3,tt.w,tt.h,
              0,GL_BGR,GL_UNSIGNED_BYTE,tt.data);

 return(0);
}

// priprava terenu *********************************************************
int glTerrain::terrain_create(unsigned char *hf)
{
 t1=0; t2=0; t3=0; t4=0;                    // priprava indexov
 q=1024.0f; w=16.0f; e=q/w; r=3.0f*1024.0f; // vyber udajov z pola

 GLfloat zf1=10.0f; // zvacsenie plochy XZ
 GLfloat zf2=2.0f;  // zvacsenie plochy Y

 // vytvorenie trojuholnikov terenu z vyskovej mapy bmp_data
 for (ty=0.0f;ty<(q-w);ty+=w) {
  for (tx=0.0f;tx<(q-w);tx+=w) {
   t1=(GLuint) (3.0f*tx+(r*ty));         // priprava indexov
   t2=(GLuint) (3.0f*(tx+w)+(r*ty));
   t3=(GLuint) (3.0f*(tx+w)+(r*(ty+w)));
   t4=(GLuint) (3.0f*tx+(r*(ty+w)));
   // lavy dolny trojuholnik
   m_glTriangle.triangle_add(zf1*(tx),  zf2*(GLfloat) hf[t1],zf1*(-ty),
                             zf1*(tx+w),zf2*(GLfloat) hf[t2],zf1*(-ty),
                             zf1*(tx),  zf2*(GLfloat) hf[t4],zf1*(-ty-w),
                             (tx)/q,  (ty)/q,
                             (tx+w)/q,(ty)/q,
                             (tx)/q,  (ty+w)/q);
   // pravy horny trojuholnik
   m_glTriangle.triangle_add(zf1*(tx+w),zf2*(GLfloat) hf[t2],zf1*(-ty),
                             zf1*(tx+w),zf2*(GLfloat) hf[t3],zf1*(-ty-w),
                             zf1*(tx),  zf2*(GLfloat) hf[t4],zf1*(-ty-w),
                             (tx+w)/q,(ty)/q,
                             (tx+w)/q,(ty+w)/q,
                             (tx)/q,  (ty+w)/q);
  }
 }

 // vyhladenie normal trojuholnikov terenu
 m_glTriangle.SmoothNormals((GLuint) ((q-w)/w*2.0f),(GLuint) ((q-w)/w));

 // po vlozeni vsetkych trojuholnikov sa naplni spojite pole
 if (m_glTriangle.create_triangle_array()) {
  printf("Chyba pri naplnani spojiteho pola trojuholnikov!"); return (1);
 }

 // priprava pamate pre texturu terenu
 texture_map.w=1024; texture_map.h=1024;
 texture_map.data=(unsigned char *) malloc(texture_map.w*texture_map.h*3);
 if (texture_map.data==NULL) {
  printf("Error allocating memory for terrain texture_map!"); return (1);
 }
 // naplnenie textury terenu farbami
 if (terrain_texture(texture_map,hf)) return(1);

 return(0);
}

